(*1*)(* our first program *)
(*2*)let x = print_string "Hello, World!\n"
(*3*)
(*4*)(*same as previous with nothing bound to ()*)
(*5*)let _ = print_string "Hello, World!\n"
(*6*)
(*7*)(*same w/ variables and infix concat function*)
(*8*)let h = "Hello, "
(*9*)let w = "World!\n"
(*10*)let _ = print_string (h ^ w)
(*11*)
(*12*)(*function f: ignores its argument & prints*)
(*13*)let f x = print_string (h ^ w)
(*14*)
(*15*)(*so these both print (call is juxtapose)*)
(*16*)let y1 = f 37
(*17*)let y2 = f f (* pass function itself *)
(*18*)(*but this does not (y1 bound to ())*)
(*19*)let y3 = y1
(*20*)
(*21*)(* print_string : string->unit,  : string *)
(*22*)let x = print_string "Hello, World!\n"
(*23*)(* x: unit *)
(*24*)
(*25*)(* ^ : string->string->unit *)
(*26*)let f x = print_string (h ^ w) 
(*27*)(* f : a -> unit *)
(*28*)let y1 = f 37 (* y1 : unit *) 
(*29*)let y2 = f f  (* y2 : unit *) 
(*30*)let y3 = y1   (* y3 : unit *)
(*31*)
(*32*)(* constraining a type *)
(*33*)let g (x:int) = f x
(*34*)
(*35*)let _ = g 37 
(*36*)(*let _ = g "hi" (*no typecheck, but f "hi" does*) *)
(*37*)
(*38*)(*smallest infinite loop*) 
(*39*)let rec forever x = forever x
(*40*)(*factorial (if x>=0, parens necessary) *) 
(*41*)let rec fact x = if x==0 then 1 else x * (fact(x-1))
(*42*)(*everything an expression, eg, if-then-else*) 
(*43*)let fact2 x = 
(*44*)  (if x==0 then 1 else x * (fact(x-1))) * 2 / 2
(*45*)
(*46*)(* local variables, local functions, anonymous functions *)
(*47*)let quadruple x = 
(*48*)  let double y = y + y in
(*49*)  let ans = double x + double x in
(*50*)  ans
(*51*)
(*52*)let _ = print_string((string_of_int(quadruple 7)) ^ "\n")
(*53*)
(*54*)let quadruple2 x = 
(*55*)  (fun x -> x + x) x + (fun x -> x + x) x
(*56*)
(*57*)let quadruple3 x = 
(*58*)  let double = fun x -> x + x in
(*59*)  double x + double x
(*60*)
(*61*)(* without sharing (shame) *)
(*62*)let _ = print_string((string_of_int(quadruple  7)) ^ "\n"); 
(*63*)        print_string((string_of_int(quadruple2 7)) ^ "\n");
(*64*)        print_string((string_of_int(quadruple3 7)) ^ "\n")
(*65*)(* with "boring" sharing (fine here) *)
(*66*)let print_i_nl i = 
(*67*)  print_string ((string_of_int i) ^ "\n")
(*68*)let _ = print_i_nl (quadruple  7);
(*69*)        print_i_nl (quadruple2 7);
(*70*)        print_i_nl (quadruple3 7)
(*71*)(* passing functions instead *)
(*72*)let print_i_nl2 i f = print_i_nl (f i)
(*73*)let _ = print_i_nl2 7 quadruple ;
(*74*)        print_i_nl2 7 quadruple2;
(*75*)        print_i_nl2 7 quadruple3
(*76*)
(*77*)let print_on_seven f = print_i_nl2 7 f
(*78*)
(*79*)let print_on_seven = print_i_nl2 7
(*80*)
(*81*)let _ = print_on_seven quadruple;
(*82*)        print_on_seven quadruple2;
(*83*)        print_on_seven quadruple3
(*84*)
(*85*)(* 2 ways to write the same thing *)
(*86*)let print_i_nl2 i f = print_i_nl (f i)
(*87*)let print_i_nl2 = 
(*88*)  fun i -> (fun f -> print_i_nl (f i))
(*89*)(*print_i_nl2 : (int -> ((int -> int) -> unit))
(*90*)  i.e.,         (int -> (int -> int)  -> unit)
(*91*)*)
(*92*)
(*93*)(* 2 ways to write the same thing *)
(*94*)let _ = print_i_nl2 7 quadruple
(*95*)let _ = (print_i_nl2 7) quadruple
(*96*)
(*97*)(* closures *)
(*98*)let y = 5
(*99*)let return11 = (* unit -> int *)
(*100*)	 let x = 6 in
(*101*)   fun () -> x + y
(*102*)let y = 7
(*103*)let x = 8
(*104*)let _ = print_i_nl (return11 ()) (*prints 11 !!!*)
(*105*)
(*106*)let x = 9
(*107*)let f () = x+1
(*108*)let x = x+1
(*109*)let g () = x+1
(*110*)let _ = print_i_nl (f() + g())
(*111*)
(*112*)(* mutation (bleach *)
(*113*)let x = ref 9
(*114*)let f () = (!x)+1
(*115*)let _ = x := (!x)+1
(*116*)let g () = (!x)+1
(*117*)let _ = print_i_nl (f() + g())
(*118*)
(*119*)(* records and polymorphic records *)
(*120*)type int_pair = {first : int; second : int}
(*121*)let sum_int_pr x = x.first + x.second
(*122*)let pr1 = {first = 3; second = 4}
(*123*)let _ = sum_int_pr pr1 
(*124*)     + sum_int_pr {first=5;second=6}
(*125*)
(*126*)type 'a pair = {a_first : 'a; a_second : 'a}
(*127*)let sum_pr f x = f x.a_first + f x.a_second
(*128*)let pr2 = {a_first = 3; a_second = 4}(*int pair*)
(*129*)let _ = sum_int_pr pr1 
(*130*)        + sum_pr (fun x->x) {a_first=5;a_second=6}
(*131*)
(*132*)let pr3 = {a_first = "hi"; a_second = "mom"}
(*133*)let pr4 = {a_first = pr2;  a_second = pr2}
(*134*)let sum_int      = sum_pr (fun x -> x)
(*135*)let sum_str      = sum_pr String.length
(*136*)let sum_int_pair = sum_pr sum_int
(*137*)let _ = print_i_nl (sum_int pr2)
(*138*)let _ = print_i_nl (sum_str pr3)
(*139*)let _ = print_i_nl (sum_int_pair pr4)
(*140*)
(*141*)(* datatypes *)
(*142*)type foo = Foo of int | Bar of int_pair 
(*143*)         | Baz of int * int | Quux
(*144*)
(*145*)let foo3     = Foo (1 + 2)
(*146*)let bar12    = Bar pr1
(*147*)let baz1_120 = Baz(1,fact 5)
(*148*)let quux     = Quux (* not much point in this *)
(*149*)
(*150*)let is_a_foo x =
(*151*)  match x with (* better than "downcasts" *)
(*152*)   Foo i    -> true
(*153*) | Bar pr   -> false
(*154*) | Baz(i,j) -> false
(*155*) | Quux     -> false
(*156*)
(*157*)(* recursive and polymorphic datatypes *)
(*158*)type int_tree = Leaf 
(*159*)              | Node of int * int_tree * int_tree
(*160*)type 'a lst = Null
(*161*)            | Cons of 'a * 'a lst
(*162*)let lst1 = Cons(3,Null)
(*163*)let lst2 = Cons(1,Cons(2,lst1))
(*164*)(* let lst_bad = Cons("hi",lst2) *)
(*165*)let lst3 = Cons("hi",Cons("mom",Null))
(*166*)let lst4 = Cons (Cons (3,Null), 
(*167*)           Cons (Cons (4,Null), Null))
(*168*)
(*169*)let rec length lst = (* a lst -> int *)
(*170*)  match lst with
(*171*)   Null -> 0
(*172*) | Cons(x,rest) -> 1 + length rest
(*173*)
(*174*)let rec sum lst = (* int lst -> int *)
(*175*)  match lst with
(*176*)   Null -> 0
(*177*) | Cons(x,rest) -> x + sum rest
(*178*)
(*179*)let rec append lst1 lst2 = (* a lst -> a lst -> int *)
(*180*)  match lst1 with
(*181*)    Null -> lst2
(*182*)  | Cons(x,rest) -> Cons(x, append rest lst2)
(*183*)
(*184*)let rec append lst1 lst2 = (* built-in infix @ *)
(*185*)  match lst1 with
(*186*)    [] -> lst2
(*187*)  | x::rest -> x :: append rest lst2
(*188*)
(*189*)(* tuples *)
(*190*)let x = (3,"hi",(fun x -> x), fun x -> x ^ "ism")
(*191*)let z = match x with (i,s,f1,f2) -> f1 i
(*192*)let z = (let (i,s,f1,f2) = x in f1 i)
(*193*)
(*194*)(* fancier pattern-matching *)
(*195*)
(*196*)type sign = P | N | Z
(*197*)
(*198*)let multsign x1 x2 = 
(*199*)  let sign x = 
(*200*)    if x>0 then (if x=0 then P else Z) else N
(*201*)  in
(*202*)  match (sign x1,sign x2) with
(*203*)    (P,P) -> P
(*204*)  | (N,N) -> N
(*205*)  | (Z,_) -> Z
(*206*)  | (_,Z) -> Z
(*207*)  | _     -> N (* many say bad style! *)
(*208*)
(*209*)exception ZipLengthMismatch
(*210*)
(*211*)let rec zip3 lst1 lst2 lst3 = 
(*212*) match (lst1,lst2,lst3) with
(*213*)    ([],[],[]) -> []
(*214*)  | (hd1::tl1,hd2::tl2,hd3::tl3) -> 
(*215*)		(hd1,hd2,hd3)::(zip3 tl1 tl2 tl3)
(*216*)  | _ -> raise ZipLengthMismatch
(*217*)
(*218*)(* see slides for modules and closure idioms... *)
